/****************************************************************************
**
** Copyright (C) 2012 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the Qt3D module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  For licensing terms and
** conditions see http://qt.digia.com/licensing.  For further information
** use the contact form at http://qt.digia.com/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Digia gives you certain additional
** rights.  These rights are described in the Digia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QGLTEAPOT_DATA_P_H
#define QGLTEAPOT_DATA_P_H

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API.  It exists purely as an
// implementation detail.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

#include "qglbezierpatches.h"

// Generated from teapot.txt by meshcvt, depth = 4

#define teapotBezierVertexCount 306
#define teapotBezierVertexStride 3
#define teapotPatchCount 32
#define teapotDepth 4
static float const teapotBezierVertexData[] = {
    0.700000f, 0.450000f, -0.000000f,
    0.700000f, 0.450000f, 0.392000f,
    0.392000f, 0.450000f, 0.700000f,
    0.000000f, 0.450000f, 0.700000f,
    0.668750f, 0.515625f, -0.000000f,
    0.668750f, 0.515625f, 0.374500f,
    0.374500f, 0.515625f, 0.668750f,
    0.000000f, 0.515625f, 0.668750f,
    0.718750f, 0.515625f, -0.000000f,
    0.718750f, 0.515625f, 0.402500f,
    0.402500f, 0.515625f, 0.718750f,
    0.000000f, 0.515625f, 0.718750f,
    0.750000f, 0.450000f, -0.000000f,
    0.750000f, 0.450000f, 0.420000f,
    0.420000f, 0.450000f, 0.750000f,
    0.000000f, 0.450000f, 0.750000f,
    -0.392000f, 0.450000f, 0.700000f,
    -0.700000f, 0.450000f, 0.392000f,
    -0.700000f, 0.450000f, -0.000000f,
    -0.374500f, 0.515625f, 0.668750f,
    -0.668750f, 0.515625f, 0.374500f,
    -0.668750f, 0.515625f, -0.000000f,
    -0.402500f, 0.515625f, 0.718750f,
    -0.718750f, 0.515625f, 0.402500f,
    -0.718750f, 0.515625f, -0.000000f,
    -0.420000f, 0.450000f, 0.750000f,
    -0.750000f, 0.450000f, 0.420000f,
    -0.750000f, 0.450000f, -0.000000f,
    -0.700000f, 0.450000f, -0.392000f,
    -0.392000f, 0.450000f, -0.700000f,
    0.000000f, 0.450000f, -0.700000f,
    -0.668750f, 0.515625f, -0.374500f,
    -0.374500f, 0.515625f, -0.668750f,
    0.000000f, 0.515625f, -0.668750f,
    -0.718750f, 0.515625f, -0.402500f,
    -0.402500f, 0.515625f, -0.718750f,
    0.000000f, 0.515625f, -0.718750f,
    -0.750000f, 0.450000f, -0.420000f,
    -0.420000f, 0.450000f, -0.750000f,
    0.000000f, 0.450000f, -0.750000f,
    0.392000f, 0.450000f, -0.700000f,
    0.700000f, 0.450000f, -0.392000f,
    0.374500f, 0.515625f, -0.668750f,
    0.668750f, 0.515625f, -0.374500f,
    0.402500f, 0.515625f, -0.718750f,
    0.718750f, 0.515625f, -0.402500f,
    0.420000f, 0.450000f, -0.750000f,
    0.750000f, 0.450000f, -0.420000f,
    0.875000f, 0.187500f, -0.000000f,
    0.875000f, 0.187500f, 0.490000f,
    0.490000f, 0.187500f, 0.875000f,
    0.000000f, 0.187500f, 0.875000f,
    1.000000f, -0.075000f, -0.000000f,
    1.000000f, -0.075000f, 0.560000f,
    0.560000f, -0.075000f, 1.000000f,
    0.000000f, -0.075000f, 1.000000f,
    1.000000f, -0.300000f, -0.000000f,
    1.000000f, -0.300000f, 0.560000f,
    0.560000f, -0.300000f, 1.000000f,
    0.000000f, -0.300000f, 1.000000f,
    -0.490000f, 0.187500f, 0.875000f,
    -0.875000f, 0.187500f, 0.490000f,
    -0.875000f, 0.187500f, -0.000000f,
    -0.560000f, -0.075000f, 1.000000f,
    -1.000000f, -0.075000f, 0.560000f,
    -1.000000f, -0.075000f, -0.000000f,
    -0.560000f, -0.300000f, 1.000000f,
    -1.000000f, -0.300000f, 0.560000f,
    -1.000000f, -0.300000f, -0.000000f,
    -0.875000f, 0.187500f, -0.490000f,
    -0.490000f, 0.187500f, -0.875000f,
    0.000000f, 0.187500f, -0.875000f,
    -1.000000f, -0.075000f, -0.560000f,
    -0.560000f, -0.075000f, -1.000000f,
    0.000000f, -0.075000f, -1.000000f,
    -1.000000f, -0.300000f, -0.560000f,
    -0.560000f, -0.300000f, -1.000000f,
    0.000000f, -0.300000f, -1.000000f,
    0.490000f, 0.187500f, -0.875000f,
    0.875000f, 0.187500f, -0.490000f,
    0.560000f, -0.075000f, -1.000000f,
    1.000000f, -0.075000f, -0.560000f,
    0.560000f, -0.300000f, -1.000000f,
    1.000000f, -0.300000f, -0.560000f,
    1.000000f, -0.525000f, -0.000000f,
    1.000000f, -0.525000f, 0.560000f,
    0.560000f, -0.525000f, 1.000000f,
    0.000000f, -0.525000f, 1.000000f,
    0.750000f, -0.637500f, -0.000000f,
    0.750000f, -0.637500f, 0.420000f,
    0.420000f, -0.637500f, 0.750000f,
    0.000000f, -0.637500f, 0.750000f,
    0.750000f, -0.675000f, -0.000000f,
    0.750000f, -0.675000f, 0.420000f,
    0.420000f, -0.675000f, 0.750000f,
    0.000000f, -0.675000f, 0.750000f,
    -0.560000f, -0.525000f, 1.000000f,
    -1.000000f, -0.525000f, 0.560000f,
    -1.000000f, -0.525000f, -0.000000f,
    -0.420000f, -0.637500f, 0.750000f,
    -0.750000f, -0.637500f, 0.420000f,
    -0.750000f, -0.637500f, -0.000000f,
    -0.420000f, -0.675000f, 0.750000f,
    -0.750000f, -0.675000f, 0.420000f,
    -0.750000f, -0.675000f, -0.000000f,
    -1.000000f, -0.525000f, -0.560000f,
    -0.560000f, -0.525000f, -1.000000f,
    0.000000f, -0.525000f, -1.000000f,
    -0.750000f, -0.637500f, -0.420000f,
    -0.420000f, -0.637500f, -0.750000f,
    0.000000f, -0.637500f, -0.750000f,
    -0.750000f, -0.675000f, -0.420000f,
    -0.420000f, -0.675000f, -0.750000f,
    0.000000f, -0.675000f, -0.750000f,
    0.560000f, -0.525000f, -1.000000f,
    1.000000f, -0.525000f, -0.560000f,
    0.420000f, -0.637500f, -0.750000f,
    0.750000f, -0.637500f, -0.420000f,
    0.420000f, -0.675000f, -0.750000f,
    0.750000f, -0.675000f, -0.420000f,
    -0.800000f, 0.262500f, -0.000000f,
    -0.800000f, 0.262500f, 0.150000f,
    -0.750000f, 0.375000f, 0.150000f,
    -0.750000f, 0.375000f, -0.000000f,
    -1.150000f, 0.262500f, -0.000000f,
    -1.150000f, 0.262500f, 0.150000f,
    -1.250000f, 0.375000f, 0.150000f,
    -1.250000f, 0.375000f, -0.000000f,
    -1.350000f, 0.262500f, -0.000000f,
    -1.350000f, 0.262500f, 0.150000f,
    -1.500000f, 0.375000f, 0.150000f,
    -1.500000f, 0.375000f, -0.000000f,
    -1.350000f, 0.150000f, -0.000000f,
    -1.350000f, 0.150000f, 0.150000f,
    -1.500000f, 0.150000f, 0.150000f,
    -1.500000f, 0.150000f, -0.000000f,
    -0.750000f, 0.375000f, -0.150000f,
    -0.800000f, 0.262500f, -0.150000f,
    -1.250000f, 0.375000f, -0.150000f,
    -1.150000f, 0.262500f, -0.150000f,
    -1.500000f, 0.375000f, -0.150000f,
    -1.350000f, 0.262500f, -0.150000f,
    -1.500000f, 0.150000f, -0.150000f,
    -1.350000f, 0.150000f, -0.150000f,
    -1.350000f, 0.037500f, -0.000000f,
    -1.350000f, 0.037500f, 0.150000f,
    -1.500000f, -0.075000f, 0.150000f,
    -1.500000f, -0.075000f, -0.000000f,
    -1.250000f, -0.187500f, -0.000000f,
    -1.250000f, -0.187500f, 0.150000f,
    -1.325000f, -0.281250f, 0.150000f,
    -1.325000f, -0.281250f, -0.000000f,
    -1.000000f, -0.300000f, 0.150000f,
    -0.950000f, -0.450000f, 0.150000f,
    -0.950000f, -0.450000f, -0.000000f,
    -1.500000f, -0.075000f, -0.150000f,
    -1.350000f, 0.037500f, -0.150000f,
    -1.325000f, -0.281250f, -0.150000f,
    -1.250000f, -0.187500f, -0.150000f,
    -0.950000f, -0.450000f, -0.150000f,
    -1.000000f, -0.300000f, -0.150000f,
    0.850000f, -0.037500f, -0.000000f,
    0.850000f, -0.037500f, 0.330000f,
    0.850000f, -0.450000f, 0.330000f,
    0.850000f, -0.450000f, -0.000000f,
    1.300000f, -0.037500f, -0.000000f,
    1.300000f, -0.037500f, 0.330000f,
    1.550000f, -0.337500f, 0.330000f,
    1.550000f, -0.337500f, -0.000000f,
    1.150000f, 0.300000f, -0.000000f,
    1.150000f, 0.300000f, 0.125000f,
    1.200000f, 0.262500f, 0.125000f,
    1.200000f, 0.262500f, -0.000000f,
    1.350000f, 0.450000f, -0.000000f,
    1.350000f, 0.450000f, 0.125000f,
    1.650000f, 0.450000f, 0.125000f,
    1.650000f, 0.450000f, -0.000000f,
    0.850000f, -0.450000f, -0.330000f,
    0.850000f, -0.037500f, -0.330000f,
    1.550000f, -0.337500f, -0.330000f,
    1.300000f, -0.037500f, -0.330000f,
    1.200000f, 0.262500f, -0.125000f,
    1.150000f, 0.300000f, -0.125000f,
    1.650000f, 0.450000f, -0.125000f,
    1.350000f, 0.450000f, -0.125000f,
    1.400000f, 0.487500f, -0.000000f,
    1.400000f, 0.487500f, 0.125000f,
    1.762500f, 0.496875f, 0.125000f,
    1.762500f, 0.496875f, -0.000000f,
    1.450000f, 0.487500f, -0.000000f,
    1.450000f, 0.487500f, 0.075000f,
    1.725000f, 0.506250f, 0.075000f,
    1.725000f, 0.506250f, -0.000000f,
    1.400000f, 0.450000f, -0.000000f,
    1.400000f, 0.450000f, 0.075000f,
    1.600000f, 0.450000f, 0.075000f,
    1.600000f, 0.450000f, -0.000000f,
    1.762500f, 0.496875f, -0.125000f,
    1.400000f, 0.487500f, -0.125000f,
    1.725000f, 0.506250f, -0.075000f,
    1.450000f, 0.487500f, -0.075000f,
    1.600000f, 0.450000f, -0.075000f,
    1.400000f, 0.450000f, -0.075000f,
    0.000000f, 0.825000f, -0.000000f,
    0.000000f, 0.825000f, 0.001000f,
    0.001000f, 0.825000f, -0.000000f,
    0.400000f, 0.825000f, -0.000000f,
    0.400000f, 0.825000f, 0.225000f,
    0.225000f, 0.825000f, 0.400000f,
    0.000000f, 0.825000f, 0.400000f,
    0.000000f, 0.675000f, -0.000000f,
    0.100000f, 0.600000f, -0.000000f,
    0.100000f, 0.600000f, 0.056000f,
    0.056000f, 0.600000f, 0.100000f,
    0.000000f, 0.600000f, 0.100000f,
    -0.001000f, 0.825000f, -0.000000f,
    -0.225000f, 0.825000f, 0.400000f,
    -0.400000f, 0.825000f, 0.225000f,
    -0.400000f, 0.825000f, -0.000000f,
    -0.056000f, 0.600000f, 0.100000f,
    -0.100000f, 0.600000f, 0.056000f,
    -0.100000f, 0.600000f, -0.000000f,
    0.000000f, 0.825000f, -0.001000f,
    -0.400000f, 0.825000f, -0.225000f,
    -0.225000f, 0.825000f, -0.400000f,
    0.000000f, 0.825000f, -0.400000f,
    -0.100000f, 0.600000f, -0.056000f,
    -0.056000f, 0.600000f, -0.100000f,
    0.000000f, 0.600000f, -0.100000f,
    0.225000f, 0.825000f, -0.400000f,
    0.400000f, 0.825000f, -0.225000f,
    0.056000f, 0.600000f, -0.100000f,
    0.100000f, 0.600000f, -0.056000f,
    0.200000f, 0.525000f, -0.000000f,
    0.200000f, 0.525000f, 0.112000f,
    0.112000f, 0.525000f, 0.200000f,
    0.000000f, 0.525000f, 0.200000f,
    0.650000f, 0.525000f, -0.000000f,
    0.650000f, 0.525000f, 0.364000f,
    0.364000f, 0.525000f, 0.650000f,
    0.000000f, 0.525000f, 0.650000f,
    0.650000f, 0.450000f, -0.000000f,
    0.650000f, 0.450000f, 0.364000f,
    0.364000f, 0.450000f, 0.650000f,
    0.000000f, 0.450000f, 0.650000f,
    -0.112000f, 0.525000f, 0.200000f,
    -0.200000f, 0.525000f, 0.112000f,
    -0.200000f, 0.525000f, -0.000000f,
    -0.364000f, 0.525000f, 0.650000f,
    -0.650000f, 0.525000f, 0.364000f,
    -0.650000f, 0.525000f, -0.000000f,
    -0.364000f, 0.450000f, 0.650000f,
    -0.650000f, 0.450000f, 0.364000f,
    -0.650000f, 0.450000f, -0.000000f,
    -0.200000f, 0.525000f, -0.112000f,
    -0.112000f, 0.525000f, -0.200000f,
    0.000000f, 0.525000f, -0.200000f,
    -0.650000f, 0.525000f, -0.364000f,
    -0.364000f, 0.525000f, -0.650000f,
    0.000000f, 0.525000f, -0.650000f,
    -0.650000f, 0.450000f, -0.364000f,
    -0.364000f, 0.450000f, -0.650000f,
    0.000000f, 0.450000f, -0.650000f,
    0.112000f, 0.525000f, -0.200000f,
    0.200000f, 0.525000f, -0.112000f,
    0.364000f, 0.525000f, -0.650000f,
    0.650000f, 0.525000f, -0.364000f,
    0.364000f, 0.450000f, -0.650000f,
    0.650000f, 0.450000f, -0.364000f,
    0.000000f, -0.750000f, -0.000000f,
    0.750000f, -0.675000f, -0.000000f,
    0.750000f, -0.675000f, -0.420000f,
    0.420000f, -0.675000f, -0.750000f,
    0.000000f, -0.675000f, -0.750000f,
    0.750000f, -0.712500f, -0.000000f,
    0.750000f, -0.712500f, -0.420000f,
    0.420000f, -0.712500f, -0.750000f,
    0.000000f, -0.712500f, -0.750000f,
    0.712500f, -0.750000f, -0.000000f,
    0.712500f, -0.750000f, -0.399000f,
    0.399000f, -0.750000f, -0.712500f,
    0.000000f, -0.750000f, -0.712500f,
    -0.420000f, -0.675000f, -0.750000f,
    -0.750000f, -0.675000f, -0.420000f,
    -0.750000f, -0.675000f, -0.000000f,
    -0.420000f, -0.712500f, -0.750000f,
    -0.750000f, -0.712500f, -0.420000f,
    -0.750000f, -0.712500f, -0.000000f,
    -0.399000f, -0.750000f, -0.712500f,
    -0.712500f, -0.750000f, -0.399000f,
    -0.712500f, -0.750000f, -0.000000f,
    -0.750000f, -0.675000f, 0.420000f,
    -0.420000f, -0.675000f, 0.750000f,
    0.000000f, -0.675000f, 0.750000f,
    -0.750000f, -0.712500f, 0.420000f,
    -0.420000f, -0.712500f, 0.750000f,
    0.000000f, -0.712500f, 0.750000f,
    -0.712500f, -0.750000f, 0.399000f,
    -0.399000f, -0.750000f, 0.712500f,
    0.000000f, -0.750000f, 0.712500f,
    0.420000f, -0.675000f, 0.750000f,
    0.750000f, -0.675000f, 0.420000f,
    0.420000f, -0.712500f, 0.750000f,
    0.750000f, -0.712500f, 0.420000f,
    0.399000f, -0.750000f, 0.712500f,
    0.712500f, -0.750000f, 0.399000f
};

static ushort const teapotPatchData[] = {
    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
    3, 16, 17, 18, 7, 19, 20, 21, 11, 22, 23, 24, 15, 25, 26, 27,
    18, 28, 29, 30, 21, 31, 32, 33, 24, 34, 35, 36, 27, 37, 38, 39,
    30, 40, 41, 0, 33, 42, 43, 4, 36, 44, 45, 8, 39, 46, 47, 12,
    12, 13, 14, 15, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59,
    15, 25, 26, 27, 51, 60, 61, 62, 55, 63, 64, 65, 59, 66, 67, 68,
    27, 37, 38, 39, 62, 69, 70, 71, 65, 72, 73, 74, 68, 75, 76, 77,
    39, 46, 47, 12, 71, 78, 79, 48, 74, 80, 81, 52, 77, 82, 83, 56,
    56, 57, 58, 59, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
    59, 66, 67, 68, 87, 96, 97, 98, 91, 99, 100, 101, 95, 102, 103, 104,
    68, 75, 76, 77, 98, 105, 106, 107, 101, 108, 109, 110, 104, 111, 112, 113,
    77, 82, 83, 56, 107, 114, 115, 84, 110, 116, 117, 88, 113, 118, 119, 92,
    120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135,
    123, 136, 137, 120, 127, 138, 139, 124, 131, 140, 141, 128, 135, 142, 143, 132,
    132, 133, 134, 135, 144, 145, 146, 147, 148, 149, 150, 151, 68, 152, 153, 154,
    135, 142, 143, 132, 147, 155, 156, 144, 151, 157, 158, 148, 154, 159, 160, 68,
    161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176,
    164, 177, 178, 161, 168, 179, 180, 165, 172, 181, 182, 169, 176, 183, 184, 173,
    173, 174, 175, 176, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196,
    176, 183, 184, 173, 188, 197, 198, 185, 192, 199, 200, 189, 196, 201, 202, 193,
    203, 203, 203, 203, 206, 207, 208, 209, 210, 210, 210, 210, 211, 212, 213, 214,
    203, 203, 203, 203, 209, 216, 217, 218, 210, 210, 210, 210, 214, 219, 220, 221,
    203, 203, 203, 203, 218, 223, 224, 225, 210, 210, 210, 210, 221, 226, 227, 228,
    203, 203, 203, 203, 225, 229, 230, 206, 210, 210, 210, 210, 228, 231, 232, 211,
    211, 212, 213, 214, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244,
    214, 219, 220, 221, 236, 245, 246, 247, 240, 248, 249, 250, 244, 251, 252, 253,
    221, 226, 227, 228, 247, 254, 255, 256, 250, 257, 258, 259, 253, 260, 261, 262,
    228, 231, 232, 211, 256, 263, 264, 233, 259, 265, 266, 237, 262, 267, 268, 241,
    269, 269, 269, 269, 278, 279, 280, 281, 274, 275, 276, 277, 270, 271, 272, 273,
    269, 269, 269, 269, 281, 288, 289, 290, 277, 285, 286, 287, 273, 282, 283, 284,
    269, 269, 269, 269, 290, 297, 298, 299, 287, 294, 295, 296, 284, 291, 292, 293,
    269, 269, 269, 269, 299, 304, 305, 278, 296, 302, 303, 274, 293, 300, 301, 270
};

#endif
